#include "ehs/io/socket/ehc/NetOp.h"
#include "ehs/io/socket/EHC.h"
#include "ehs/io/socket/ehc/NetEnd.h"

namespace ehs
{
	NetOp::NetOp()
		: hashId(0)
	{
	}

	NetOp::NetOp(Str_8 id)
		: hashId(id.Hash_64()), id((Str_8 &&)id)
	{
	}

	NetOp::NetOp(NetOp&& op) noexcept
		: hashId(op.hashId), id((Str_8 &&)op.id)
	{
		op.hashId = 0;
	}

	NetOp::NetOp(const NetOp &op)
		: hashId(op.hashId), id(op.id)
	{
	}

	NetOp& NetOp::operator=(NetOp&& op) noexcept
	{
		if (this == &op)
			return *this;

		hashId = op.hashId;
		id = (Str_8 &&)op.id;

		op.hashId = 0;

		return *this;
	}

	NetOp &NetOp::operator=(const NetOp &op)
	{
		if (this == &op)
			return *this;

		hashId = op.hashId;
		id = op.id;

		return *this;
	}

	Str_8 NetOp::GetId() const
	{
		return id;
	}

	UInt_64 NetOp::GetHashId() const
	{
		return hashId;
	}

	void NetOp::Execute(NetChannel *channel, NetEnd *endpoint, NetSys *sys, Serializer<UInt_64> &payload)
	{
	}
}